# Populating Next Right Pointers in Each Node

Medium(https://leetcode.com/problems/populating-next-right-pointers-in-each-node/submissions/)

You are given a **perfect binary tree** where all leaves are on the same level, and every parent has two children. The binary tree has the following definition:

`struct Node {`

int val;

Node *left;

Node *right;

Node *next;

}

Populate each next pointer to point to its next right node. If there is no next right node, the next pointer should be set to `NULL`

.

Initially, all next pointers are set to `NULL`

.

**Follow up:**

- You may only use constant extra space.
- Recursive approach is fine, you may assume implicit stack space does not count as extra space for this problem.

**Example 1:**

**Input:** root = [1,2,3,4,5,6,7]

**Output:** [1,#,2,3,#,4,5,6,7,#]

**Explanation: **Given the above perfect binary tree (Figure A), your function should populate each next pointer to point to its next right node, just like in Figure B. The serialized output is in level order as connected by the next pointers, with '#' signifying the end of each level.

**Constraints:**

- The number of nodes in the given tree is less than
`4096`

. `-1000 <= node.val <= 1000`

**Solution:**

`# first intuition is BFS traversal and `

# pop the left and point to the node on the 0th element of the tree.

# append all the elements left to right.

Code:

"""

# Definition for a Node.

class Node:

def __init__(self, val: int = 0, left: 'Node' = None, right: 'Node' = None, next: 'Node' = None):

self.val = val

self.left = left

self.right = right

self.next = next

"""class Solution:

def connect(self, root: 'Node') -> 'Node':

# first intuition is BFS traversal and

# pop the left and point to the node on the 0th element of the tree.

# append all the elements , also nulls.

if not root:

return root

q = collections.deque()

q.append(root)

while q:

length = len(q)

for i in range(length):

node = q.popleft()

if i < length -1:

node.next = q[0]

if node.left: q.append(node.left)

if node.right: q.append(node.right)

return root

**Complexity Analysis**

- Time Complexity: O(N) since we process each node exactly once. Note that processing a node in this context means popping the node from the queue and then establishing the next pointers.
- Space Complexity: O(N). This is a perfect binary tree which means the last level contains N/2 nodes. The space complexity for breadth first traversal is the space occupied by the queue which is dependent upon the maximum number of nodes in particular level. So, in this case, the space complexity would be O(N).

Success

Runtime: 64 ms, faster than 51.47% of Python3 online submissions for Populating Next Right Pointers in Each Node.

Memory Usage: 15.8 MB, less than 23.04% of Python3 online submissions for Populating Next Right Pointers in Each Node.

**Next to Try:**